<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.png" usemap="#OpenSim::MocoTropterSolver::TropterProblemBase_3C_20T_20_3E_map" alt=""/>
  <map id="OpenSim::MocoTropterSolver::TropterProblemBase_3C_20T_20_3E_map" name="OpenSim::MocoTropterSolver::TropterProblemBase_3C_20T_20_3E_map">
<area href="classOpenSim_1_1MocoTropterSolver_1_1ExplicitTropterProblem.html" alt="OpenSim::MocoTropterSolver::ExplicitTropterProblem&lt; T &gt;" shape="rect" coords="0,112,343,136"/>
<area href="classOpenSim_1_1MocoTropterSolver_1_1ImplicitTropterProblem.html" alt="OpenSim::MocoTropterSolver::ImplicitTropterProblem&lt; T &gt;" shape="rect" coords="353,112,696,136"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ac05f1989e272a20d7731f09de5c2ea97"><td class="memTemplParams" colspan="2">template&lt;typename MocoTrajectoryType , typename tropIterateType &gt; </td></tr>
<tr class="memitem:ac05f1989e272a20d7731f09de5c2ea97"><td class="memTemplItemLeft" align="right" valign="top">MocoTrajectoryType&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#ac05f1989e272a20d7731f09de5c2ea97">convertIterateTropterToMoco</a> (const tropIterateType &amp;tropSol) const</td></tr>
<tr class="separator:ac05f1989e272a20d7731f09de5c2ea97"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abbace7ac065e345b47c65a6225e35b2a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#abbace7ac065e345b47c65a6225e35b2a">convertToMocoTrajectory</a> (const tropter::Iterate &amp;tropSol) const</td></tr>
<tr class="separator:abbace7ac065e345b47c65a6225e35b2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a182ca3f2b26960a30003ac85aba6b145"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1MocoSolution.html">MocoSolution</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a182ca3f2b26960a30003ac85aba6b145">convertToMocoSolution</a> (const tropter::Solution &amp;tropSol) const</td></tr>
<tr class="separator:a182ca3f2b26960a30003ac85aba6b145"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7cd5f97fe85c8a7c0ccc96ee7b6b071f"><td class="memItemLeft" align="right" valign="top">tropter::Iterate&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a7cd5f97fe85c8a7c0ccc96ee7b6b071f">convertToTropterIterate</a> (const <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> &amp;mocoIter) const</td></tr>
<tr class="separator:a7cd5f97fe85c8a7c0ccc96ee7b6b071f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a5d911ac064c0b2decc700e3084ea177b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5d911ac064c0b2decc700e3084ea177b">&#9670;&nbsp;</a></span>TropterProblemBase()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::<a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">TropterProblemBase</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1MocoTropterSolver.html">MocoTropterSolver</a> &amp;&#160;</td>
          <td class="paramname"><em>solver</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>implicit</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a808880626da2e126e7f14fa5cb3ae1eb">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::addControlVariables()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a9c4b0e48d6c919b2c8802b2d9b0ff87a">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::addCosts()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a010d18e045701d564302519ea7defdad">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::addGenericPathConstraints()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a704bf161ccf676b08dc3d0cc671b23a6">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::addKinematicConstraints()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a931dd4b95e5ba8e44395c7c18981ae5a">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::addParameters()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a598829729d95ef8070331977ba5a9c77">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::addStateVariables()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a7f9a246863d142f993f066bee8e0ac17">OpenSim::MocoProblemRep::createStateVariableNamesInSystemOrder()</a>, <a class="el" href="group__commonutil.html#gaee5c8bd6f089ca1cdebdb5d47606caf7">OpenSim::getFormattedDateTime()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#ab6ea1ad7ea4cf20a1133439ef2509b31">OpenSim::MocoProblemRep::getName()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a7a4015233307aaaec5c0ed70abcb05b7">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_fileDeletionThrower</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a24abac8b8f3d3334269d381fd32de60d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_modelBase</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#aa2423aee1be43dbf3be2fcf2dd1052b8">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_stateBase</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a6f1364771977fdac257569214caff8b1">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_svNamesInSysOrder</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a06daa1fb7715ebd8f33abd46644cf59f">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_yIndexMap</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a808880626da2e126e7f14fa5cb3ae1eb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a808880626da2e126e7f14fa5cb3ae1eb">&#9670;&nbsp;</a></span>addControlVariables()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::addControlVariables </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="namespaceOpenSim.html#a13f93b43c9a582ae34ce336fb1fe85d6">OpenSim::convertBounds()</a>, <a class="el" href="group__simulationutil.html#gaae85359eb9db792e3cc9d4a673e20086">OpenSim::createControlNamesFromModel()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#ae09331e727ec7733d017e8ac03a943f2">OpenSim::MocoProblemRep::getControlInfo()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a24abac8b8f3d3334269d381fd32de60d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_modelBase</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#af47e6985f83a5199516f3e47c38944b0">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_modelControlIndices</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a5d911ac064c0b2decc700e3084ea177b">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::TropterProblemBase()</a>.</p>

</div>
</div>
<a id="a9c4b0e48d6c919b2c8802b2d9b0ff87a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9c4b0e48d6c919b2c8802b2d9b0ff87a">&#9670;&nbsp;</a></span>addCosts()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::addCosts </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a237e04675314b8628b31d7cbd32cb318">OpenSim::MocoProblemRep::createCostNames()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a5235196596fae561d918af037e9cff8b">OpenSim::MocoProblemRep::getCost()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a8dadaa613c8955d2da7aff7dd4a54e6a">OpenSim::MocoProblemRep::getNumEndpointConstraints()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a07d5ff1d9c9d9bab13a3a7a732dedc18">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoTropterSolver</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a49a06d7fe350b26d293291fe24b1e72e">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_multiplierCostIndex</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a5d911ac064c0b2decc700e3084ea177b">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::TropterProblemBase()</a>.</p>

</div>
</div>
<a id="a010d18e045701d564302519ea7defdad"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a010d18e045701d564302519ea7defdad">&#9670;&nbsp;</a></span>addGenericPathConstraints()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::addGenericPathConstraints </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Add any generic path constraints included in the problem. </p>

<p class="reference">References <a class="el" href="namespaceOpenSim.html#a13f93b43c9a582ae34ce336fb1fe85d6">OpenSim::convertBounds()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a4daab0b4b7db92ad879adfe5809bfeb8">OpenSim::MocoProblemRep::createPathConstraintNames()</a>, <a class="el" href="classOpenSim_1_1MocoPathConstraint.html#a3e20fc835380551c64053691da8be48e">OpenSim::MocoPathConstraint::getConstraintInfo()</a>, <a class="el" href="classOpenSim_1_1MocoConstraintInfo.html#aaf07b61a2665a072559f216f8fb69fe7">OpenSim::MocoConstraintInfo::getConstraintLabels()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a86079545c623bcd79e726272a3b63d0f">OpenSim::MocoProblemRep::getNumPathConstraintEquations()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a943d099b6fc81d78a0636890047b7a19">OpenSim::MocoProblemRep::getPathConstraint()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a1887ddafbd71b2d106696057c0037d4a">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_numPathConstraintEquations</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a5d911ac064c0b2decc700e3084ea177b">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::TropterProblemBase()</a>.</p>

</div>
</div>
<a id="a704bf161ccf676b08dc3d0cc671b23a6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a704bf161ccf676b08dc3d0cc671b23a6">&#9670;&nbsp;</a></span>addKinematicConstraints()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::addKinematicConstraints </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaeca3b926d163371fd620b09b63219b12f52">OpenSim::Acceleration</a>, <a class="el" href="namespaceOpenSim.html#a13f93b43c9a582ae34ce336fb1fe85d6">OpenSim::convertBounds()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a3642ba4e02c2d8402caba84d7fd258a1">OpenSim::MocoProblemRep::createKinematicConstraintNames()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#ae7f43d1888830926c611b990ef03ef9a">OpenSim::MocoProblemRep::getKinematicConstraint()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#ac0edeb9a49d5abae813dbfad15314f4f">OpenSim::MocoProblemRep::getMultiplierInfos()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a07d5ff1d9c9d9bab13a3a7a732dedc18">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoTropterSolver</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a94f762e7a24fb4db3e532a07f3e22d61">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_numKinematicConstraintEquations</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a1a5e8d1b9c90829fde3ab98b18f95471">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_numMultipliers</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a662b5247552bd21fb57d753f62223ea5">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_total_ma</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a7219dde7664cf05e4b274eea9d8d03ae">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_total_mp</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a0e472072f03268b6968b2274ae55469e">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_total_mv</a>, <a class="el" href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaeca52f5e0bc3859bc5f5e25130b6c7e8881">OpenSim::Position</a>, and <a class="el" href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaeca88156d46910a2d733443c339a9231d12">OpenSim::Velocity</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a5d911ac064c0b2decc700e3084ea177b">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::TropterProblemBase()</a>.</p>

</div>
</div>
<a id="a931dd4b95e5ba8e44395c7c18981ae5a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a931dd4b95e5ba8e44395c7c18981ae5a">&#9670;&nbsp;</a></span>addParameters()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::addParameters </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="namespaceOpenSim.html#a13f93b43c9a582ae34ce336fb1fe85d6">OpenSim::convertBounds()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#aacce6424758772be3a73b0eecfc871b3">OpenSim::MocoProblemRep::createParameterNames()</a>, <a class="el" href="classOpenSim_1_1MocoParameter.html#a21e61bbd148326de530d745a72af79a3">OpenSim::MocoParameter::getBounds()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a7d86a57b8ac7f8050f7dbd4a02870cb4">OpenSim::MocoProblemRep::getParameter()</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a5d911ac064c0b2decc700e3084ea177b">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::TropterProblemBase()</a>.</p>

</div>
</div>
<a id="a598829729d95ef8070331977ba5a9c77"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a598829729d95ef8070331977ba5a9c77">&#9670;&nbsp;</a></span>addStateVariables()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::addStateVariables </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="namespaceOpenSim.html#a13f93b43c9a582ae34ce336fb1fe85d6">OpenSim::convertBounds()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#aa9fb5fe53df5fdb00ade12cb5cc59015">OpenSim::MocoProblemRep::getStateInfo()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a4f24672c592fc3f71a018d077daa6b50">OpenSim::MocoProblemRep::getTimeFinalBounds()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a9fc7af266aa5a76af2d231cb257abbef">OpenSim::MocoProblemRep::getTimeInitialBounds()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a6f1364771977fdac257569214caff8b1">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_svNamesInSysOrder</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a5d911ac064c0b2decc700e3084ea177b">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::TropterProblemBase()</a>.</p>

</div>
</div>
<a id="a8c82ea5464ed2c8006ea6131cbdf5588"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8c82ea5464ed2c8006ea6131cbdf5588">&#9670;&nbsp;</a></span>applyParametersToModelProperties()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::applyParametersToModelProperties </td>
          <td>(</td>
          <td class="paramtype">const tropter::VectorX&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>parameters</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Apply parameters to properties in <code>m_modelBase</code> and <code>m_modelDisabledConstraints</code>. </p>

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a7436000bd26c1a09ed7e978450367fbe">OpenSim::MocoProblemRep::applyParametersToModelProperties()</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#abc4f928fb5a6be8594703808a4a10dd5">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::initialize_on_iterate()</a>.</p>

</div>
</div>
<a id="ac5bc22e3a6598fc09caa16bfa2c4cc6a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac5bc22e3a6598fc09caa16bfa2c4cc6a">&#9670;&nbsp;</a></span>calc_cost()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::calc_cost </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>cost_index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const tropter::CostInput&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">T &amp;&#160;</td>
          <td class="paramname"><em>cost_value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoProblemRep.html#aa9ebce7e2a142b465fe558e57259a28d">OpenSim::MocoProblemRep::getCostByIndex()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#aa3d31c37311994caa89255bcc170721e">OpenSim::MocoProblemRep::getDiscreteControllerDisabledConstraints()</a>, <a class="el" href="classOpenSim_1_1DiscreteController.html#ac324893ec5952efafad80b1b67a1a6ef">OpenSim::DiscreteController::getDiscreteControls()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a49a06d7fe350b26d293291fe24b1e72e">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_multiplierCostIndex</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#afdadbfd395c88088b685a0034e8f5f2a">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::setSimTKStateForCostFinal()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a4701452d9a143cafa19ebf07bfc8e6ec">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::setSimTKStateForCostInitial()</a>, and <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a6e9116d7b4b06d355d3f42a0291c778d">OpenSim::MocoProblemRep::updStateDisabledConstraints()</a>.</p>

</div>
</div>
<a id="a9f248c1d9d4049f4be9ef243973c15dd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9f248c1d9d4049f4be9ef243973c15dd">&#9670;&nbsp;</a></span>calc_cost_integrand()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::calc_cost_integrand </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>cost_index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const tropter::Input&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">T &amp;&#160;</td>
          <td class="paramname"><em>integrand</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoGoal.html#af5f21ef76eb2e08397aa40bac99eecff">OpenSim::MocoGoal::calcIntegrand()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#aa9ebce7e2a142b465fe558e57259a28d">OpenSim::MocoProblemRep::getCostByIndex()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#aa3d31c37311994caa89255bcc170721e">OpenSim::MocoProblemRep::getDiscreteControllerDisabledConstraints()</a>, <a class="el" href="classOpenSim_1_1DiscreteController.html#ac324893ec5952efafad80b1b67a1a6ef">OpenSim::DiscreteController::getDiscreteControls()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a07d5ff1d9c9d9bab13a3a7a732dedc18">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoTropterSolver</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a49a06d7fe350b26d293291fe24b1e72e">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_multiplierCostIndex</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a1a5e8d1b9c90829fde3ab98b18f95471">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_numMultipliers</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a2e7257cfc49917c107ab35150448726c">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_stateDisabledConstraints</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a02874c535c804fe74e5c2eedb3da20e9">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::setSimTKState()</a>.</p>

</div>
</div>
<a id="a9892042d0aff0b5b6f01e017b7351b2b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9892042d0aff0b5b6f01e017b7351b2b">&#9670;&nbsp;</a></span>calcAndApplyKinematicConstraintForces()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::calcAndApplyKinematicConstraintForces </td>
          <td>(</td>
          <td class="paramtype">const tropter::VectorX&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>adjuncts</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>stateBase</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>stateDisabledConstraints</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a2fe10098fa75d90c087af713aafd6589">OpenSim::MocoProblemRep::getConstraintForces()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#ab345f853e5e404fec66273e61dc26eb4">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_constraintBodyForces</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#ab7ecc1d23e2b5b211e4196f6634f0b57">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_constraintMobilityForces</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a24abac8b8f3d3334269d381fd32de60d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_modelBase</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a1a5e8d1b9c90829fde3ab98b18f95471">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_numMultipliers</a>, and <a class="el" href="classOpenSim_1_1DiscreteForces.html#aae4c63f0eab84f9704ae640c256ae071">OpenSim::DiscreteForces::setAllForces()</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a7f7d3a3d0b635432f3c86deacfe5dcb9">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::setSimTKState()</a>.</p>

</div>
</div>
<a id="a2a25a4c4ff48bcdcac9fe1bcfdb8f1ab"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2a25a4c4ff48bcdcac9fe1bcfdb8f1ab">&#9670;&nbsp;</a></span>calcKinematicConstraintErrors()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::calcKinematicConstraintErrors </td>
          <td>(</td>
          <td class="paramtype">const SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>udot</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">tropter::Output&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>out</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a07d5ff1d9c9d9bab13a3a7a732dedc18">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoTropterSolver</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a24abac8b8f3d3334269d381fd32de60d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_modelBase</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#aceee7b0fdb7e5669c04f42d5919b7758">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_pvaerr</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#aa2423aee1be43dbf3be2fcf2dd1052b8">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_stateBase</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a662b5247552bd21fb57d753f62223ea5">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_total_ma</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a7219dde7664cf05e4b274eea9d8d03ae">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_total_mp</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a0e472072f03268b6968b2274ae55469e">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_total_mv</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1ExplicitTropterProblem.html#a394c71db23b4d9d799cc953cdc5d547f">OpenSim::MocoTropterSolver::ExplicitTropterProblem&lt; T &gt;::calc_differential_algebraic_equations()</a>.</p>

</div>
</div>
<a id="a591dfa4e85b475205e0cd4fbb432c961"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a591dfa4e85b475205e0cd4fbb432c961">&#9670;&nbsp;</a></span>calcPathConstraintErrors()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::calcPathConstraintErrors </td>
          <td>(</td>
          <td class="paramtype">const SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>state</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">tropter::Output&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>out</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a283d2751fb69ebb2b06dc0d964c68f88">OpenSim::MocoProblemRep::calcPathConstraintErrors()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a94f762e7a24fb4db3e532a07f3e22d61">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_numKinematicConstraintEquations</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1ExplicitTropterProblem.html#a394c71db23b4d9d799cc953cdc5d547f">OpenSim::MocoTropterSolver::ExplicitTropterProblem&lt; T &gt;::calc_differential_algebraic_equations()</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1ImplicitTropterProblem.html#ab5dc53df48a33a10cefb79e50f489d67">OpenSim::MocoTropterSolver::ImplicitTropterProblem&lt; T &gt;::calc_differential_algebraic_equations()</a>.</p>

</div>
</div>
<a id="ac05f1989e272a20d7731f09de5c2ea97"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac05f1989e272a20d7731f09de5c2ea97">&#9670;&nbsp;</a></span>convertIterateTropterToMoco()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<div class="memtemplate">
template&lt;typename MocoTrajectoryType , typename tropIterateType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">MocoTrajectoryType <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::convertIterateTropterToMoco </td>
          <td>(</td>
          <td class="paramtype">const tropIterateType &amp;&#160;</td>
          <td class="paramname"><em>tropSol</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a182ca3f2b26960a30003ac85aba6b145"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a182ca3f2b26960a30003ac85aba6b145">&#9670;&nbsp;</a></span>convertToMocoSolution()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1MocoSolution.html">MocoSolution</a> <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::convertToMocoSolution </td>
          <td>(</td>
          <td class="paramtype">const tropter::Solution &amp;&#160;</td>
          <td class="paramname"><em>tropSol</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="abbace7ac065e345b47c65a6225e35b2a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abbace7ac065e345b47c65a6225e35b2a">&#9670;&nbsp;</a></span>convertToMocoTrajectory()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::convertToMocoTrajectory </td>
          <td>(</td>
          <td class="paramtype">const tropter::Iterate &amp;&#160;</td>
          <td class="paramname"><em>tropSol</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a7cd5f97fe85c8a7c0ccc96ee7b6b071f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7cd5f97fe85c8a7c0ccc96ee7b6b071f">&#9670;&nbsp;</a></span>convertToTropterIterate()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">tropter::Iterate <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::convertToTropterIterate </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> &amp;&#160;</td>
          <td class="paramname"><em>mocoIter</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="abc4f928fb5a6be8594703808a4a10dd5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abc4f928fb5a6be8594703808a4a10dd5">&#9670;&nbsp;</a></span>initialize_on_iterate()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::initialize_on_iterate </td>
          <td>(</td>
          <td class="paramtype">const Eigen::VectorXd &amp;&#160;</td>
          <td class="paramname"><em>parameters</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">final</span><span class="mlabel">override</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a8c82ea5464ed2c8006ea6131cbdf5588">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::applyParametersToModelProperties()</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a7a4015233307aaaec5c0ed70abcb05b7">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_fileDeletionThrower</a>.</p>

</div>
</div>
<a id="a7f7d3a3d0b635432f3c86deacfe5dcb9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7f7d3a3d0b635432f3c86deacfe5dcb9">&#9670;&nbsp;</a></span>setSimTKState() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::setSimTKState </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Eigen::Ref&lt; const tropter::VectorX&lt; T &gt;&gt; &amp;&#160;</td>
          <td class="paramname"><em>states</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Eigen::Ref&lt; const tropter::VectorX&lt; T &gt;&gt; &amp;&#160;</td>
          <td class="paramname"><em>controls</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Eigen::Ref&lt; const tropter::VectorX&lt; T &gt;&gt; &amp;&#160;</td>
          <td class="paramname"><em>adjuncts</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>stateDisConIndex</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Use <code>stateDisConIndex</code> to specify which of the two stateDisabledConstraints from <a class="el" href="classOpenSim_1_1MocoProblemRep.html" title="The primary intent of this class is for use by MocoSolvers, but users can also use this class to appl...">MocoProblemRep</a> to update. </p>

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a9892042d0aff0b5b6f01e017b7351b2b">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::calcAndApplyKinematicConstraintForces()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a4278a510ab93ddac80d4d9b8acdfc1ce">OpenSim::MocoProblemRep::getAccelerationMotion()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#aa3d31c37311994caa89255bcc170721e">OpenSim::MocoProblemRep::getDiscreteControllerDisabledConstraints()</a>, <a class="el" href="classOpenSim_1_1MocoProblemRep.html#ae48c88f2e7d56f5eb5cd63ecaf0352bd">OpenSim::MocoProblemRep::isPrescribedKinematics()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#ae3ae389bf1803effec14a7fd2a0aaad1">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_implicit</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a3eea7a48a863fad0c663dcfd33e73a3d">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_mocoProbRep</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#af47e6985f83a5199516f3e47c38944b0">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_modelControlIndices</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a1f8f04b99e1fe47483e039e35197dea0">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_modelDisabledConstraints</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a94f762e7a24fb4db3e532a07f3e22d61">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_numKinematicConstraintEquations</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#aa2423aee1be43dbf3be2fcf2dd1052b8">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_stateBase</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#afe0e15845a945621e965456da231221c">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::setSimTKTimeAndStates()</a>, <a class="el" href="classOpenSim_1_1DiscreteController.html#a81320c91c0ce62a4b5fa99ba048aeb79">OpenSim::DiscreteController::updDiscreteControls()</a>, and <a class="el" href="classOpenSim_1_1MocoProblemRep.html#a6e9116d7b4b06d355d3f42a0291c778d">OpenSim::MocoProblemRep::updStateDisabledConstraints()</a>.</p>

</div>
</div>
<a id="a02874c535c804fe74e5c2eedb3da20e9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a02874c535c804fe74e5c2eedb3da20e9">&#9670;&nbsp;</a></span>setSimTKState() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::setSimTKState </td>
          <td>(</td>
          <td class="paramtype">const tropter::Input&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>in</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a9f248c1d9d4049f4be9ef243973c15dd">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::calc_cost_integrand()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1ExplicitTropterProblem.html#a394c71db23b4d9d799cc953cdc5d547f">OpenSim::MocoTropterSolver::ExplicitTropterProblem&lt; T &gt;::calc_differential_algebraic_equations()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1ImplicitTropterProblem.html#ab5dc53df48a33a10cefb79e50f489d67">OpenSim::MocoTropterSolver::ImplicitTropterProblem&lt; T &gt;::calc_differential_algebraic_equations()</a>, <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#afdadbfd395c88088b685a0034e8f5f2a">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::setSimTKStateForCostFinal()</a>, and <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a4701452d9a143cafa19ebf07bfc8e6ec">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::setSimTKStateForCostInitial()</a>.</p>

</div>
</div>
<a id="afdadbfd395c88088b685a0034e8f5f2a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afdadbfd395c88088b685a0034e8f5f2a">&#9670;&nbsp;</a></span>setSimTKStateForCostFinal()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::setSimTKStateForCostFinal </td>
          <td>(</td>
          <td class="paramtype">const tropter::CostInput&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>in</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a02874c535c804fe74e5c2eedb3da20e9">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::setSimTKState()</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#ac5bc22e3a6598fc09caa16bfa2c4cc6a">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::calc_cost()</a>.</p>

</div>
</div>
<a id="a4701452d9a143cafa19ebf07bfc8e6ec"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4701452d9a143cafa19ebf07bfc8e6ec">&#9670;&nbsp;</a></span>setSimTKStateForCostInitial()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::setSimTKStateForCostInitial </td>
          <td>(</td>
          <td class="paramtype">const tropter::CostInput&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>in</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a02874c535c804fe74e5c2eedb3da20e9">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::setSimTKState()</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#ac5bc22e3a6598fc09caa16bfa2c4cc6a">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::calc_cost()</a>.</p>

</div>
</div>
<a id="afe0e15845a945621e965456da231221c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afe0e15845a945621e965456da231221c">&#9670;&nbsp;</a></span>setSimTKTimeAndStates()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">OpenSim::MocoTropterSolver::TropterProblemBase</a>&lt; T &gt;::setSimTKTimeAndStates </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Eigen::Ref&lt; const tropter::VectorX&lt; T &gt;&gt;&#160;</td>
          <td class="paramname"><em>states</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>simTKState</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a06daa1fb7715ebd8f33abd46644cf59f">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::m_yIndexMap</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html#a7f7d3a3d0b635432f3c86deacfe5dcb9">OpenSim::MocoTropterSolver::TropterProblemBase&lt; T &gt;::setSimTKState()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Moco/tropter/TropterProblem.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1MocoTropterSolver.html">MocoTropterSolver</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1MocoTropterSolver_1_1TropterProblemBase.html">TropterProblemBase</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:47 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
